# seconda versione di istover che stampa tutti i valori delle
# ascisse dallo '0' fino alla 'z'
#
# vedi Homework Lezione 4
#
def print_matrix(m, maxord):
	# stampa la matrice dall'alto verso il basso */
	r = maxord
	c = 0
	
	while r >= 0:

		for c in range(0, ord('z') - ord('0')):
			print(m[r][c], end="")
			
		r = r - 1
		print("") # a capo
		
	for i in range(ord('0'), ord('z') + 1):
		print(chr(i), end="")
		
	print("") # a capo

def istover(astring):
	maxrows = len(astring)
	maxcols = ord('z') - ord('0') 
	maxord = 0 # massimo valore dell'ordinata

	# creo e popolo la matrice di soli spazi
	matrix = []
	row = []
	# preparo una riga di maxcols elementi
	for c in range(0, maxcols):
		row.append(' ')
	
	# inserisco maxrows righe uguali a row
	# NOTA BENE!! devo fare una copia di row ogni volta
	# prima di passarlo ad append perche' python passa i
	# parametri per OBJECT REFERENCE, quindi ogni cambiamento
	# su un vettore riga si ripercuoterebbe su tutte le righe!
	#
	for r in range(0, maxrows):
		matrix.append(row[:])
		
	
	for i in range(0, len(astring)):
		
		r = 0 # indice di riga
		
		if ord(astring[i]) >= ord('0') and ord(astring[i]) <= ord('z'):
			caratt = ord(astring[i]) - ord('0')
		
			# salto gli elementi che hanno gia' un '*' 
			# sulla colonna corrispondente al carattere
			# caratt e sulla riga r
		
			# perche' maxrows - 1 ??
			while (r < maxrows - 1) and caratt < maxcols and  (matrix[r][caratt] != ' '):
				r = r + 1
		
			if caratt < maxcols:
				matrix[r][caratt] = '*'

			if maxord < r:
				maxord = r
		
	print_matrix(matrix, maxord)		

	
